package com.me.common.ecs;

public class ComponentBag {

    private Component[] items;
    private int size;

    public ComponentBag() {
        this.items = new Component[16];
        this.size = items.length;
    }

    public Component get(int index) {
        if (index > size) {
            throw new IndexOutOfBoundsException("index > size");
        }
        return items[index];
    }

    public void insert(int index, Component item) {
        if (index >= size) {
            grow((int) (index * 1.5f));
        }
        items[index] = item;
    }

    public void remove(int index) {
        if (index >= size) {
            throw new IndexOutOfBoundsException("index must be < size");
        }
        items[index] = null;
    }

    private void grow(int newSize) {
        Component[] newItems = new Component[newSize];
        System.arraycopy(this.items, 0, newItems, 0, size);
        size = newSize;
        this.items = newItems;
    }

}
